﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Collections;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;
using System.Drawing;
using System.Windows.Forms;
using xColor = Microsoft.Xna.Framework.Graphics.Color;
using Color = System.Drawing.Color;
using xButtonState = Microsoft.Xna.Framework.Input.ButtonState;
using xRectangle = Microsoft.Xna.Framework.Rectangle;
using xPoint = Microsoft.Xna.Framework.Point;
using Point = System.Drawing.Point;

namespace LED_Editor
{
    [Serializable]
    public class FrameManager
    {
        public List<Frame> frames;
        public int count;
        public int current;
        public double time;

        public FrameManager()
        {
            frames = new List<Frame>();
            count = 0;
            current = 0;
            time = 250;
        }

        public void MoveRight(Panel[,] panels, bool circle)
        {
            SaveToFrame(panels);
            current++;
            if (current == count)
            {
                if (circle == true)
                    current = 0;
                else
                    current--;
            }
            update(panels, current);
        }

        public void MoveLeft(Panel[,] panels,bool circle)
        {
            SaveToFrame(panels);
            current--;
            if (current == -1)
            {
                if (circle == true)
                    current = count - 1;
                else
                    current = 0;
            }
            update(panels, current);
        }

        public void AddFrame(Panel[,] panels)
        {
            frames.Insert(current, new Frame());
            count++;

            update(panels, current);
        }

        public void DelFrame(Panel[,] panels)
        {
            if (count == 1)
                return;
            frames.RemoveAt(current);
            count--;

            if (current == count)
                current--;
            update(panels, current);
        }

        public void InsertFrame(Panel[,] panels)
        {
            SaveToFrame(panels);

            current++;
            frames.Insert(current, new Frame());
            count++;

            update(panels, current);
        }

        public void CopyBefore(Panel[,] panels)
        {
            if (current == 0)
                return;
            int a, b;
            for (a = 0; a < 8; a++)
                for (b = 0; b < 8; b++)
                    panels[a, b].BackColor = frames[current - 1].data[a, b];
        }

        private void update(Panel[,] panels, int cur)
        {
            int a, b;
            for (a = 0; a < 8; a++)
                for (b = 0; b < 8; b++)
                    panels[a, b].BackColor = frames[current].data[a, b];
        }

        public void SaveToFrame(Panel[,] panels)
        {
            int a, b;
            for (a = 0; a < 8; a++)
                for (b = 0; b < 8; b++)
                    frames[current].data[a, b] = panels[a, b].BackColor;
        }

        public void Update(Panel[,] panels)
        {
            update(panels, current);
        }
    }
}
