﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;
using Microsoft.VisualBasic;
using System.Drawing;
using System.Windows.Forms;
using System.IO;
using System.Diagnostics;
using System.Text.RegularExpressions;
using System.Runtime.Serialization.Formatters.Binary;
using xColor = Microsoft.Xna.Framework.Graphics.Color;
using Color = System.Drawing.Color;
using xButtonState = Microsoft.Xna.Framework.Input.ButtonState;
using xRectangle = Microsoft.Xna.Framework.Rectangle;
using xPoint = Microsoft.Xna.Framework.Point;
using Point = System.Drawing.Point;
using xKeys = Microsoft.Xna.Framework.Input.Keys;

namespace LED_Editor
{
    public partial class Game1
    {
        public List<int[,]> ColorToInt(List<Frame> frame)
        {
            List<int[,]> list = new List<int[,]>();
            int a,b,c;
            for (a = 0; a < frame.Count(); a++)
            {
                int[,] temp = new int[8, 8];
                for (b = 0; b < 8; b++)
                {
                    for (c = 0; c < 8; c++)
                    {
                        if(frame[a].data[b,c] == Color.White)
                            temp[b,c] = 0;
                        else if(frame[a].data[b,c] == Color.Red)
                            temp[b,c] = 1;
                    }
                }
                list.Add(temp);
            }
            return list;
        }
        public int ExecuteCommand(string Command, int Timeout)
        {
            int ExitCode;
            ProcessStartInfo ProcessInfo;
            Process Process;
            ProcessInfo = new ProcessStartInfo("cmd.exe", "/C " + Command);
            ProcessInfo.CreateNoWindow = true;
            ProcessInfo.UseShellExecute = false;
            Process = Process.Start(ProcessInfo);
            Process.WaitForExit(Timeout);
            ExitCode = Process.ExitCode;
            Process.Close();
            return ExitCode;
        }
        public bool CheckSize(string Command, int Timeout)
        {
            int count =0;
            ProcessStartInfo ProcessInfo;
            Process Process;
            ProcessInfo = new ProcessStartInfo("cmd.exe", "/C " + Command);
            ProcessInfo.CreateNoWindow = true;
            ProcessInfo.UseShellExecute = false;
            ProcessInfo.RedirectStandardOutput = true;
            Process = Process.Start(ProcessInfo);
            string stdout = Process.StandardOutput.ReadToEnd();
            string[] line = stdout.Split('\n');
            string[] lines = Regex.Split(line[1],@"[' ']+");
            Process.WaitForExit(Timeout);
            Process.Close();
            if(lines[0]=="") count++;
            MessageBox.Show("FileSize(Max 14336) = "+(Int32.Parse(lines[count]) + Int32.Parse(lines[count + 1])));
            if (Int32.Parse(lines[count]) + Int32.Parse(lines[count + 1]) > 14335) return false;
            return true;
        }
        public string ToPort(int[,] array)
        {
            string code = "";
            for (int i = 0; i < 8; i++)
            {
                code += "\tPORTB = 0b00";
                if (i == 5) code += "1"; else code += "0";
                if (array[i, 6] == 1) code += "0"; else code += "1";
                if (i == 2) code += "1"; else code += "0";
                if (i == 1) code += "1"; else code += "0";
                if (array[i, 3] == 1) code += "0"; else code += "1";
                if (i == 3) code += "1"; else code += "0";
                code += ";\n\t\t\t";
                code += "PORTC = 0b00";
                if (array[i, 2] == 1) code += "0"; else code += "1";
                if (array[i, 0] == 1) code += "0"; else code += "1";
                if (array[i, 4] == 1) code += "0"; else code += "1";
                if (array[i, 1] == 1) code += "0"; else code += "1";
                if (i == 7) code += "1"; else code += "0";
                if (i == 6) code += "1"; else code += "0";
                code += ";\n\t\t\t";
                code += "PORTD = 0b0";
                if (array[i, 7] == 1)
                    if (i != 1 && i != 7) code += "0"; else code += "1";
                else code += "1";
                if (i == 4) code += "1"; else code += "0";
                code += "000";
                if (array[i, 5] == 1) code += "0"; else code += "1";
                if (i == 0) code += "1"; else code += "0";
                code += ";\n\t\t\t";
                code += ";\n\t\t\t_delay_ms(1);\n\t\t";
            }
            if (array[1, 7] == 1)
            {
                code += "PORTC = 0b00111100;\n\t\t\t";
                code += "PORTB = 0b00010110;\n\t\t\tPORTD = 0b00000010;\n\t\t\t_delay_ms(1);\n\t\t\t";
            }
            if (array[7, 7] == 1)
            {
                code += "PORTC = 0b00111110;\n\t\t\t";
                code += "PORTB = 0b00010010;\n\t\t\tPORTD = 0b00000010;\n\t\t\t_delay_ms(1);\n\t\t";
            }
            return code;
        }
        public int GenBurn(FrameManager frameManager)
        {
            int time = (int)(frameManager.time);
            StreamWriter writer = new StreamWriter("temp.c");
            string code = "#define F_CPU 16000000UL\n#include <avr/io.h>\n#include <util/delay.h>\n\n";
            code += "main()\n{\n\tDDRB = 0b00111111;\n\tDDRC = 0b00111111;\n\tDDRD = 0b01100011;\n\t";
            code += "while(1)\n\t{\n\t\tint i;\n\t";
            List<int[,]> frame = ColorToInt(frameManager.frames);
            int round = frame.Count();
            for (int i = 0; i < round; i++)
            {
                int multiplier = (int)(time * 0.095);
                code += ("\tfor(i=0;i<" + multiplier + ";i++)\n\t\t{\n\t\t");
                code += ToPort(frame[i]);
                code += "}\n\t";
            }
            code += "}\n}";
            writer.Write(code);
            writer.Close();
            if (ExecuteCommand("avr-gcc -mmcu=atmega168 -O -o temp.elf temp.c", 100000) == 1) return 1;
            ExecuteCommand("avr-objcopy -j .text -j .data -O ihex temp.elf temp.hex", 100000);
            if (!CheckSize("avr-size temp.elf", 100000)) return 3;
            if (ExecuteCommand("avrdude -p atmega168 -c usbasp -U flash:w:temp.hex", 100000) == 1) return 2;
            return 0;
        }
        //---------------------------------------------------------------------------------------------
        public void SwapColor(Panel panel)
        {
            if (panel.BackColor == colors[0])
                panel.BackColor = colors[1];
            else if (panel.BackColor == colors[1])
                panel.BackColor = colors[0];
            frameManager.SaveToFrame(panels);
        }

        private void InitPanel()
        {
            int x = 190, y = 120; // Can be init to anywhere
            int size = 27;

            for (int a = 0; a < 8; a++)
            {
                for (int b = 0; b < 8; b++)
                {
                    panels[a, b] = new Panel();
                    panels[a, b].Size = new Size(size, size);
                    panels[a, b].Location = new System.Drawing.Point(x + b * (size+1), y + a * (size+1));
                    panels[a, b].Visible = true;
                    panels[a, b].BackColor = colors[0];
                    panels[a, b].BorderStyle = BorderStyle.None;
                    //panels[a, b].MouseHover += new EventHandler(Panel_MouseOver);
                    panels[a, b].Tag = String.Format("{0} {1}", a, b);
                    form.Controls.Add(panels[a, b]);
                }
            }

            Panel panel = new Panel();
            panel.Size = new Size(9 * size - 10, 9 * size - 10);
            panel.Location = new Point(185, 115);
            panel.BackColor = Color.Black;
            panel.BorderStyle = BorderStyle.FixedSingle;
            form.Controls.Add(panel);
        }

        private void SwapAll()
        {
            int a, b;
            for (a = 0; a < 8; a++)
                for (b = 0; b < 8; b++)
                    SwapColor(panels[a, b]);
            frameManager.SaveToFrame(panels);
        }
        public void Swap_Click(object sender, EventArgs e)
        {
            SwapAll();
        }

        public void RedAll()
        {
            int a, b;
            for (a = 0; a < 8; a++)
                for (b = 0; b < 8; b++)
                    panels[a, b].BackColor = colors[1];
            frameManager.SaveToFrame(panels);
        }
        public void Red_Click(object sender, EventArgs e)
        {
            RedAll();
        }

        public void WhiteAll()
        {
            int a, b;
            for (a = 0; a < 8; a++)
                for (b = 0; b < 8; b++)
                    panels[a, b].BackColor = colors[0];
            frameManager.SaveToFrame(panels);
        }
        public void White_Click(object sender, EventArgs e)
        {
            WhiteAll();
        }

        public void Swap0_Click(object sender, EventArgs e)
        {
            firstColor = Color.Black;
            ClearOneClick();
        }
        public void White0_Click(object sender, EventArgs e)
        {
            firstColor = Color.White;
        }
        public void Red0_Click(object sender, EventArgs e)
        {
            firstColor = Color.Red;
        }

        public void Insert_Click(object sender, EventArgs e)
        {
            frameManager.InsertFrame(panels);
        }
        public void Copy_Click(object sender, EventArgs e)
        {
            frameManager.CopyBefore(panels);
            frameManager.SaveToFrame(panels);
        }
        public void Del_Click(object sender, EventArgs e)
        {
            frameManager.DelFrame(panels);
        }

        public void New_Click(object sender, EventArgs e)
        {
            New();
        }
        public void New()
        {
            frameManager = new FrameManager();
            frameManager.AddFrame(panels);
        }

        public void Open_Click(object sender, EventArgs e)
        {
            Open();
        }
        public void Open()
        {
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.Title = "Load Data";
            dialog.Filter = "Data File|*.data";
            dialog.Multiselect = false;
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                FileStream flStream = new FileStream(dialog.FileName, FileMode.Open, FileAccess.Read);
                try
                {
                    BinaryFormatter binFormatter = new BinaryFormatter();
                    frameManager = (FrameManager)binFormatter.Deserialize(flStream);
                    frameManager.Update(panels);
                }
                finally
                {
                    flStream.Close();
                }
            }
        }

        public void Save_Click(object sender, EventArgs e)
        {
            Save(frameManager);
        }
        public void Save(FrameManager frameManager)
        {
            SaveFileDialog dialog = new SaveFileDialog();
            dialog.Title = "Save Data";
            dialog.Filter = "Data File|*.data";
            dialog.InitialDirectory = System.IO.Directory.GetCurrentDirectory();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                FileStream flStream = new FileStream(dialog.FileName,FileMode.OpenOrCreate, FileAccess.Write);
                try
                {
                    BinaryFormatter binFormatter = new BinaryFormatter();
                    binFormatter.Serialize(flStream, frameManager);
                }
                finally
                {
                    flStream.Close();
                }
            }
        }

        public void Burn()
        {
            int status = GenBurn(frameManager);
            if (status == 0)
                MessageBox.Show("BurnStatus : Passed!!");
            else if (status == 1)
                MessageBox.Show("BurnStatus : Compile Failed!!");
            else if (status == 2)
                MessageBox.Show("BurnStatus : Burn Failed!!");
            else if (status == 3)
                MessageBox.Show("BurnStatus : FileSize Exceed Limit!!");
        }

        public void Burn_Click(object sender, EventArgs e)
        {
            Burn();
        }

        private void InitButton()
        {
            Button btnRed = new Button();
            Button btnWhite = new Button();
            Button btnSwap = new Button();
            Button btnRed0 = new Button();
            Button btnWhite0 = new Button();
            Button btnSwap0 = new Button();
            Button btnInsert = new Button();
            Button btnCopy = new Button();
            Button btnDel = new Button();
            Button btnNew = new Button();
            Button btnOpen = new Button();
            Button btnSave = new Button();
            Button btnBurn = new Button();

            Size btnSize = new Size(80, 30);

            btnBurn.Size = btnSize + new Size(20, 0);
            btnBurn.Location = new Point(470, 10);
            btnBurn.Visible = true;
            btnBurn.Text = "Burn (Ctrl + B)";
            btnBurn.Click += new EventHandler(Burn_Click);

            btnNew.Size = btnSize + new Size(20, 0);
            btnNew.Location = new Point(10, 10);
            btnNew.Visible = true;
            btnNew.Text = "New (Ctrl + N)";
            btnNew.Click += new EventHandler(New_Click);

            btnOpen.Size = btnSize + new Size(20, 0); ;
            btnOpen.Location = new Point(10 + 120, 10);
            btnOpen.Visible = true;
            btnOpen.Text = "Open (Ctrl + O)";
            btnOpen.Click += new EventHandler(Open_Click);

            btnSave.Size = btnSize + new Size(20, 0); ;
            btnSave.Location = new Point(10 + 240, 10);
            btnSave.Visible = true;
            btnSave.Text = "Save (Ctrl + S)";
            btnSave.Click += new EventHandler(Save_Click);

            btnInsert.Size = btnSize;
            btnInsert.Location = new Point(160, 480);
            btnInsert.Visible = true;
            btnInsert.Text = "Insert (Q)";
            btnInsert.Click += new EventHandler(Insert_Click);

            btnCopy.Size = btnSize;
            btnCopy.Location = new Point(160 + 100, 480);
            btnCopy.Visible = true;
            btnCopy.Text = "CopyBefore (C)";
            btnCopy.Click += new EventHandler(Copy_Click);

            btnDel.Size = btnSize;
            btnDel.Location = new Point(160 + 200, 480);
            btnDel.Visible = true;
            btnDel.Text = "Delete (I)";
            btnDel.Click += new EventHandler(Del_Click);

            btnSwap0.Size = btnSize;
            btnSwap0.Location = new Point(30, 175);
            btnSwap0.Visible = true;
            btnSwap0.Text = "Swap (1)";
            btnSwap0.Click += new EventHandler(Swap0_Click);

            btnWhite0.Size = btnSize;
            btnWhite0.Location = new Point(30, 175 + 40);
            btnWhite0.Visible = true;
            btnWhite0.Text = "White (2)";
            btnWhite0.Click += new EventHandler(White0_Click);

            btnRed0.Size = btnSize;
            btnRed0.Location = new Point(30, 175 + 80);
            btnRed0.Visible = true;
            btnRed0.Text = "Red (3)";
            btnRed0.Click += new EventHandler(Red0_Click);

            btnSwap.Size = btnSize;
            btnSwap.Location = new Point(460, 175);
            btnSwap.Visible = true;
            btnSwap.Text = "SwapAll (F1)";
            btnSwap.Click += new EventHandler(Swap_Click);

            btnWhite.Size = btnSize;
            btnWhite.Location = new Point(460, 175 + 40);
            btnWhite.Visible = true;
            btnWhite.Text = "WhiteAll (F2)";
            btnWhite.Click += new EventHandler(White_Click);

            btnRed.Size = btnSize;
            btnRed.Location = new Point(460, 175 + 80);
            btnRed.Visible = true;
            btnRed.Text = "RedAll (F3)";
            btnRed.Click += new EventHandler(Red_Click);

            form.Controls.Add(btnRed);
            form.Controls.Add(btnWhite);
            form.Controls.Add(btnSwap);
            form.Controls.Add(btnRed0);
            form.Controls.Add(btnSwap0);
            form.Controls.Add(btnWhite0);
            form.Controls.Add(btnInsert);
            form.Controls.Add(btnCopy);
            form.Controls.Add(btnDel);
            form.Controls.Add(btnNew);
            form.Controls.Add(btnOpen);
            form.Controls.Add(btnSave);
            form.Controls.Add(btnBurn);
        }
    }
}
