﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.VisualBasic;
using Microsoft.Xna.Framework.Storage;
using System.Drawing;
using System.Windows.Forms;
using xColor = Microsoft.Xna.Framework.Graphics.Color;
using Color = System.Drawing.Color;
using xButtonState = Microsoft.Xna.Framework.Input.ButtonState;
using xRectangle = Microsoft.Xna.Framework.Rectangle;
using xPoint = Microsoft.Xna.Framework.Point;
using Point = System.Drawing.Point;
using xKeys = Microsoft.Xna.Framework.Input.Keys;

namespace LED_Editor
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public partial class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        Panel[,] panels = new Panel[8, 8];
        bool[,] oneClick = new bool[8, 8];
        Color[] colors = { Color.White, Color.Red , Color.Black};
        xColor[] xColors = { xColor.White, xColor.Red, xColor.Black };
        MouseState oldMouse = new MouseState();
        Color firstColor = Color.Red;
        bool hasClick = false;

        double MOUSE_DELAY = 250;
        double mouseTime = 0;

        double keyTime = 0;
        double KEY_DELAY = 150;

        double playTime = 0;

        double delTime = 0;
        double DEL_DELAY = 300;

        Form form;

        FrameManager frameManager;
        SpriteFont font;

        Texture2D leftArrow, rightArrow;

        //----------------------------------------------------------

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
            graphics.PreferredBackBufferHeight = 560;
            graphics.PreferredBackBufferWidth = 580;
            this.IsMouseVisible = true;
            form = Control.FromHandle(Window.Handle) as Form;
            frameManager = new FrameManager();
        }

        protected override void Initialize()
        {
            // TODO: Add your initialization logic here
            InitPanel();
            InitButton();

            frameManager.AddFrame(panels);

            base.Initialize();
        }

        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            font = Content.Load<SpriteFont>("font");
            leftArrow = Content.Load<Texture2D>("leftArrow");
            rightArrow = Content.Load<Texture2D>("rightArrow");

            // TODO: use this.Content to load your game content here
        }

        private void ClearOneClick()
        {
            int a, b;
            for (a = 0; a < 8; a++)
                for (b = 0; b < 8; b++)
                    oneClick[a, b] = false;
        }

        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        private bool IsInRect(Vector2 point, xRectangle rect)
        {
            if (point.X < rect.Left || point.X > rect.Right)
                return false;
            if (point.Y < rect.Top || point.Y > rect.Bottom)
                return false;
            return true;
        }

        public bool boxEnd = true;
        public string timeInput;
        private void OpenBox()
        {
            if (boxEnd == false)
                return;
            boxEnd = false;
            string sInput = Interaction.InputBox("Hello", "Enter something fun", "Type something", 100, 100);
            if (sInput != null)
            {
                boxEnd = true;
                try
                {
                    frameManager.time = Double.Parse(sInput);
                }
                catch
                {
                    Console.WriteLine("เลขสิวะ - -");
                }
            }
        }

        protected override void Update(GameTime gameTime)
        {
            if (IsActive == false)
                return;
            MouseState mouseState = Mouse.GetState();

//Console.WriteLine("{0} {1}", mouseState.X, mouseState.Y);
            
            mouseTime += gameTime.ElapsedGameTime.TotalMilliseconds;
            keyTime   += gameTime.ElapsedGameTime.TotalMilliseconds;
            delTime   += gameTime.ElapsedGameTime.TotalMilliseconds;
            playTime += gameTime.ElapsedGameTime.TotalMilliseconds;

            int a,b;
            if (mouseState.LeftButton == xButtonState.Pressed)
            {
                Vector2 mousePos = new Vector2(mouseState.X, mouseState.Y);
                for (a = 0; a < 8; a++)
                {
                    for (b = 0; b < 8; b++)
                    {
                        xRectangle rect = new xRectangle(panels[a, b].Location.X, panels[a, b].Location.Y, panels[a, b].Size.Width, panels[a, b].Size.Height);
                        if (IsInRect(mousePos, rect) == false)
                            continue;
                            
                        if (firstColor == Color.Black)
                        {
                            if (hasClick == false)
                                hasClick = true;
                            if (oneClick[a, b] == false)
                            {
                                SwapColor(panels[a, b]);
                                oneClick[a, b] = true;
                            }
                        }
                        else if(firstColor == colors[1])
                            panels[a, b].BackColor = colors[1];
                        else if (firstColor == colors[0])
                            panels[a, b].BackColor = colors[0];
                    }
                }
                frameManager.SaveToFrame(panels); 
                if (IsInArrow(new Vector2(230, 400), leftArrow, mousePos) && mouseTime >= MOUSE_DELAY)
                {
                    frameManager.MoveLeft(panels, true);
                    mouseTime = 0;
                }
                if (IsInArrow(new Vector2(310, 400), rightArrow, mousePos) && mouseTime >= MOUSE_DELAY)
                {
                    frameManager.MoveRight(panels, true);
                    mouseTime = 0;
                }
            }
            if (mouseState.LeftButton == xButtonState.Released)
            {
                hasClick = false;
                ClearOneClick();
            }
              

            KeyboardState keyState = Keyboard.GetState();

            if (keyState.IsKeyDown(xKeys.D1))
            {
                firstColor = Color.Black;
                ClearOneClick();
            }
            else if (keyState.IsKeyDown(xKeys.T))
            {
                OpenBox();
            }
            else if (keyState.IsKeyDown(xKeys.D2))
                firstColor = colors[0];
            else if (keyState.IsKeyDown(xKeys.D3))
                firstColor = colors[1];
            else if (keyState.IsKeyDown(xKeys.F1) && keyTime >= KEY_DELAY)
            {
                keyTime = 0;
                SwapAll();
            }
            else if (keyState.IsKeyDown(xKeys.F2))
                WhiteAll();
            else if (keyState.IsKeyDown(xKeys.F3))
                RedAll();
            if (keyState.IsKeyDown(xKeys.D) && keyTime >= KEY_DELAY)
            {
                frameManager.MoveRight(panels, true);
                keyTime = 0;
            }
            else if (keyState.IsKeyDown(xKeys.A) && keyTime >= KEY_DELAY)
            {
                frameManager.MoveLeft(panels, true);
                keyTime = 0;
            }
            else if (keyState.IsKeyDown(xKeys.Q) && keyTime >= KEY_DELAY)
            {
                frameManager.InsertFrame(panels);
                keyTime = 0;
            }
            else if (keyState.IsKeyDown(xKeys.C) && keyTime >= KEY_DELAY)
            {
                frameManager.CopyBefore(panels);
                frameManager.SaveToFrame(panels);
                keyTime = 0;
            }
            else if (keyState.IsKeyDown(xKeys.I) && delTime >= DEL_DELAY)
            {
                frameManager.DelFrame(panels);
                delTime = 0;
            }
            else if (keyState.IsKeyDown(xKeys.Z) && playTime >= frameManager.time)
            {
                frameManager.MoveLeft(panels,true);
                playTime = 0;
            }
            else if (keyState.IsKeyDown(xKeys.X) && playTime >= frameManager.time)
            {
                frameManager.MoveRight(panels, true);
                playTime = 0;
            }
            else if (keyState.IsKeyDown(xKeys.LeftControl) && keyState.IsKeyDown(xKeys.N))
            {
                New();
            }
            else if (keyState.IsKeyDown(xKeys.LeftControl) && keyState.IsKeyDown(xKeys.O))
            {
                Open();
            }
            else if (keyState.IsKeyDown(xKeys.LeftControl) && keyState.IsKeyDown(xKeys.S))
            {
                Save(frameManager);
            }
            else if (keyState.IsKeyDown(xKeys.LeftControl) && keyState.IsKeyDown(xKeys.B) && keyTime >= KEY_DELAY)
            {
                keyTime = 0;
                Burn();
            }

            frameManager.Update(panels);
            oldMouse = mouseState;
            base.Update(gameTime);
        }

        public bool IsInArrow(Vector2 pos, Texture2D texture, Vector2 mousePos)
        {
            xRectangle rect = new xRectangle((int)pos.X, (int)pos.Y, (int)(texture.Width), (int)(texture.Height));
            if (mousePos.X < rect.Left || mousePos.X > rect.Right)
                return false;
            if (mousePos.Y < rect.Top || mousePos.Y > rect.Bottom)
                return false;
            return true;
        }
        
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(xColor.CornflowerBlue);

            // TODO: Add your drawing code here
            Texture2D boxColor = new Texture2D(GraphicsDevice,1,1);
            xColor[] color = new xColor[1];
            if (firstColor == colors[1])
                color[0] = xColors[1];
            if (firstColor == colors[0])
                color[0] = xColors[0];
            if (firstColor == Color.Black)
                color[0] = xColor.Black;
            boxColor.SetData<xColor>(color);

            spriteBatch.Begin();
            spriteBatch.Draw(boxColor, new xRectangle(140, 215, 25, 25), xColor.White);
            spriteBatch.DrawString(font,string.Format("Frame {0} from {1}",frameManager.current+1,frameManager.count),new Vector2(225,355),xColor.Black);
            spriteBatch.Draw(leftArrow, new Vector2(230, 400), xColor.White);
            spriteBatch.Draw(rightArrow, new Vector2(310, 400), xColor.White);
            spriteBatch.End();

            base.Draw(gameTime);
        }
    }
}
